package ffmpegconverter;

import java.util.ArrayList;
import java.util.List;

public class Parser {

    /**
     * Tokenizes a string
     * @param input <p>A string.</p>
     * @return <p>A list of tokens.</p>
     */
    public static List<String> tokenize(String input) {
        List<String> tokens = new ArrayList<>();
        boolean startedQuote = false;
        StringBuilder currentToken = new StringBuilder();
        for (int i = 0; i < input.length(); i++) {
            char c = input.charAt(i);
            switch (c) {
                case ' ':
                    if (!startedQuote) {
                        //If not inside "", a space marks the end of a parameter
                        if (!currentToken.toString().trim().equals("")) {
                            tokens.add(currentToken.toString());
                            currentToken = new StringBuilder();
                        } else {
                            currentToken = new StringBuilder();
                        }
                    } else {
                        currentToken.append(c);
                    }
                    break;
                case '"':
                    if (startedQuote) {
                        if (!currentToken.toString().trim().equals("")) {
                            tokens.add(currentToken.toString());
                            currentToken = new StringBuilder();
                        }
                        startedQuote = false;
                    } else {
                        startedQuote = true;
                        currentToken = new StringBuilder();
                    }   break;
                default:
                    currentToken.append(c);
                    if (i == input.length() - 1) {
                        tokens.add(currentToken.toString());
                    }   break;
            }
        }
        return tokens;
    }
}
